<template>
  <div class="header">
    <h1>Категории</h1>
    <div class="header__btns">
      <my-button @click="openDialog">Создать</my-button>
    </div>
  </div>
  <breadcrumbs :items="breadcrumbs" @changeParent="changeParentFromBreadcrumbs"/>
  <div class="categories">
    <category-list
        :categories="categories"
        @changeParent="changeParent"
        @edit="editCategory"
        @remove="remove"
    />
  </div>
  <pagination :pageTotal="pageTotal" :currentPage="page" @update="changePage"/>
  <my-dialog v-model:show="dialogVisible">
    <category-form
        :editing="editing"
        :categoryForEdit="this.categoryForEdit"
        @createCategory="create"
        @editCategory="edit"
    />
  </my-dialog>
</template>

<script>
import CategoryList from "@/components/categories/CategoryList";
import axios from "axios";
import Breadcrumbs from "@/components/categories/Breadcrumbs";
import CategoryForm from "@/components/categories/CategoryForm";

export default {
  name: 'CategoriesView',
  components: {
    CategoryForm,
    Breadcrumbs,
    CategoryList
  },
  data() {
    return {
      categories: [],
      breadcrumbs: [{value: 'Все', id: null}],
      parentId: null,
      page: 1,
      limit: 10,
      total: 0,
      pageTotal: 0,
      dialogVisible: false,
      categoryForEdit: null,
      editing: false,
    }
  },
  methods: {
    changePage(page) {
      this.page = page
      this.fetching()
    },
    openDialog() {
      this.dialogVisible = true
    },
    changeParent(category) {
      this.parentId = category.id
      this.breadcrumbs.push({
        value: category.value,
        id: category.id
      })
      this.fetching()
    },
    changeParentFromBreadcrumbs(categoryId) {
      const index = this.breadcrumbs.findIndex(i => i.id === categoryId)
      this.breadcrumbs = this.breadcrumbs.slice(0, index + 1);
      this.parentId = categoryId
      this.fetching()
    },
    editCategory (category) {
      this.categoryForEdit = category
      this.editing = true
      this.openDialog()
    },
    async remove (category) {
      try {
        const response = await axios.delete(`/api/category/${category.id}`)
        this.fetching()
      } catch (e) {
        alert("Ошибка!")
        console.log(e)
      }
    },
    async create (value) {
      try {
        const response = await axios.post('/api/category', {
          value: value,
          parent_id: this.parentId,
        })
        this.dialogVisible = false
        this.fetching()
      } catch (e) {
        alert("Ошибка!")
        console.log(e)
      }
    },
    async edit (category) {
      try {
        const response = await axios.put(`/api/category/${category.id}`, {
          value: category.value,
          parent_id: category.parent_id,
        })
        this.dialogVisible = false
        this.categoryForEdit = null
        this.editing = false
        this.fetching()
      } catch (e) {
        alert("Ошибка!")
        console.log(e)
      }
    },
    async fetching () {
      try {
        const response = await axios.get('/api/category', {
          params: {
            page: this.page,
            limit: this.limit,
            parent_id: this.parentId,
          }
        })
        this.categories = response.data.data;
        this.total = response.data.total
        this.pageTotal = Math.ceil(this.total / this.limit)
      } catch (e) {
        alert("Ошибка!")
        console.log(e)
      }
    }
  },
  mounted() {
    this.fetching()
  }
}
</script>

<style>
.header {
  margin: 20px 0;
  display: flex;
  justify-content: space-between;
}
.categories {
  display: flex;
  flex-direction: column;
  background: rgba(200, 200, 200, .4);
}
</style>
